
#include <math.h>
#include <vector>
#include <algorithm>
#include<iostream>
#include <string>
#include <sstream>
#include <fstream>
#include <limits>
#include <array>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cmath>
#include <Windows.h>
#include "BaseballPlayer.h"
#include "Team.h"



/***************************************************************************/
/***************************************************************************/



using namespace std;

//fcns
void makePlayerArray(Player p[]);
void makeTeamsArray(string t[]);
double findDifferenceSHOW(Team t[], int n);
double findDifferenceNOSHOW(Team t[], int n);
void draftTeam(string nm, Player team[], double & score, Player p[], int teamSize);
void createLeague(int numt, string teams[], Player p[], Team league[]);
int setupNumTeams();
int setupNumLeagues();
void swapArrays(Team arr1[], Team arr2[], int s);
void tradePlayers(Team league[], int n, int m, int r);
void copyArrays(Team multi[], Team nextgen[], int numleag, int t);
void playerMutation(Team league[], int n, int m, int r);

//vars
const int NUMTEAMS = 30;
const int NUMLEAGUES = 30;


/***************************************************************************/
/***************************************************************************/


int main()
{
	//SETUP

	Player playerArray[playerSize];
	makePlayerArray(playerArray);     //call a function to create array of Player

	string allTeams[NUMTEAMS];
	makeTeamsArray(allTeams);

	//const int ACTUALTEAMS = setupNumTeams();
	const int ACTUALLEAGUES = setupNumLeagues();

	const int ACTUALTEAMS = 16;//KEEP HERE
	//const int ACTUALLEAGUES = 10;

	Team** multiLeagues;
	multiLeagues = new Team *[NUMLEAGUES];  // CAN BE A VARIABLE with number of Leagues from the user
	for (int m = 0; m < ACTUALLEAGUES; m++)
		multiLeagues[m] = new Team[NUMTEAMS];  // CAN BE A VARIABLE with number of teams in league from user
	//cout << "sizeof(multiLeagues): " << sizeof(multiLeagues) << endl << endl;

	cout << "GENERATION 0!" << endl;
	//Create intial random generations
	for (int i = 0; i < ACTUALLEAGUES; i++)  //PUSHBACK LEAGUES
	{
		createLeague(ACTUALTEAMS, allTeams, playerArray, multiLeagues[i]);
		findDifferenceSHOW(multiLeagues[i], ACTUALTEAMS);
		multiLeagues[i]->releaseAll(playerArray);
	}


	cout << "========================================================================" << endl << endl;
	//system("pause");


	cout << "**********************************************************" << endl;
	cout << "numTrades = ACTUALLEAGUES - numMutations - numTopDogs" << endl;
	cout << "**********************************************************" << endl << endl;

	//ADJUSTABLE FACTORS
	int numGenDisplay;
	cout << "Enter how often you want generations to display (50 would mean every 50th generation is displayed)" << endl;
	cin >> numGenDisplay;
	if (numGenDisplay <= 0 || numGenDisplay > 500)
	{
		cout << "ERROR ERROR ERROR... numGenDisplay is illegal size" << endl;
		exit(EXIT_FAILURE);
	}
	



	//int numTopDogs = 2;
	int numTopDogs;
	cout << "NumTopDogs (leagues that automatically move on) per Generation:  ";
	cin >> numTopDogs; cout << endl;

	int gencount = 1;
	if (numTopDogs >= ACTUALLEAGUES || numTopDogs <= 0)
	{
		cout << "ERROR ERROR ERROR... numTopDogs is illegal size" << endl;
		exit(EXIT_FAILURE);
	}
	//NUM TRADES
	//int numTrades;
	//cout << "Trades per Generation:  ";
	//cin >> numTrades; cout << endl;

	//NUM MUTATIONS

	int numMutations;
	cout << "numMutations per Generation:  ";
	cin >> numMutations; cout << endl;

	if ((numMutations + numTopDogs) > ACTUALLEAGUES)
	{
		cout << "ERROR ERROR ERROR... numMutations is illegal size" << endl;
		exit(EXIT_FAILURE);
	}

	int numTrades = ACTUALLEAGUES - numMutations - numTopDogs;

	//NUM GENS
	//int numGenerations;
	//cout << "Number of Generations:  ";
	//cin >> numGenerations;

	int random_league;
	int random_league_mut;

	double maxDifference[NUMLEAGUES];
	int numloops = 0;
	srand(time(0));

	//GENERATION LOOP
	while (true)
	{
		//if (numloops >= numGenerations)
		//	break;  // LEAVES WHILE LOOP

		for (int i = 0; i < ACTUALLEAGUES; i++)
			maxDifference[i] = findDifferenceNOSHOW(multiLeagues[i], ACTUALTEAMS);

		//SORTS LEAGUES IN SOLUTION BY WAR
		Team temp[NUMTEAMS];
		for (int i = 0; i < ACTUALLEAGUES; i++)
		{
			for (int j = i + 1; j < ACTUALLEAGUES; j++)
			{
				if (maxDifference[i] > maxDifference[j])
				{
					swapArrays(temp, multiLeagues[i], ACTUALTEAMS);
					swapArrays(multiLeagues[i], multiLeagues[j], ACTUALTEAMS);
					swapArrays(multiLeagues[j], temp, ACTUALTEAMS);
					swap(maxDifference[i], maxDifference[j]);
				}

				for (int i = 0; i < ACTUALLEAGUES; i++)
				{
					findDifferenceNOSHOW(multiLeagues[i], ACTUALTEAMS);
				}
			}
		}


		//Create array for NEXT GEN
		Team** nextGen;
		nextGen = new Team *[NUMLEAGUES];
		for (int m = 0; m < ACTUALLEAGUES; m++)
			nextGen[m] = new Team[NUMTEAMS];
		for (int i = 0; i < numTopDogs; i++)     //place top num of leagues (numTopDog) into next gen automatically
		{
			copyArrays(nextGen[i], multiLeagues[i], ACTUALLEAGUES, ACTUALTEAMS);
		}


		//cout << endl << "here!!!" << endl;
		//for (int i = 0; i < ACTUALLEAGUES; i++)  //PUSHBACK LEAGUES
		//{
		//	findDifferenceSHOW(nextGen[i], ACTUALTEAMS);
		//}


		////Crossover Original
		//for (int i = 0; i < numTrades; i++)
		//{
		//	random_league = rand() % ACTUALLEAGUES + 0;
		//	tradePlayers(multiLeagues[random_league], ACTUALTEAMS, ACTUALLEAGUES, random_league);
		//}


		//Crossover TRIAL
		int nextGenCtr = numTopDogs;
		//	for (int i = numTopDogs; i < ACTUALLEAGUES; i++)
		for (int i = 0; i < numTrades; i++)
		{
			random_league = rand() % ACTUALLEAGUES + 0;
			copyArrays(nextGen[nextGenCtr], multiLeagues[random_league], ACTUALLEAGUES, ACTUALTEAMS);
			tradePlayers(nextGen[nextGenCtr], ACTUALTEAMS, ACTUALLEAGUES, random_league);

			//	copyArrays(nextGen[nextGenCtr], multiLeagues[random_league], ACTUALLEAGUES, ACTUALTEAMS);
			nextGenCtr++;
		}


		//Mutate 
		for (int i = 0; i < numMutations; i++)
		{
			random_league_mut = rand() % ACTUALLEAGUES;
			copyArrays(nextGen[nextGenCtr], multiLeagues[random_league_mut], ACTUALLEAGUES, ACTUALTEAMS);
			//playerMutation(multiLeagues[random_league], ACTUALTEAMS, ACTUALLEAGUES, random_league);
			playerMutation(nextGen[nextGenCtr], ACTUALTEAMS, ACTUALLEAGUES, random_league_mut);
			nextGenCtr++;
			//cout << endl << endl;
		}



		////Copy crossover leagues into next gen (except first of original)
		//for (int i = numTopDogs; i < ACTUALLEAGUES; i++)
		//{
		//	copyArrays(nextGen[i], multiLeagues[i], ACTUALLEAGUES, ACTUALTEAMS);
		//}


		//copy next gen into multiLeague
		for (int i = 0; i < ACTUALLEAGUES; i++)
		{
			copyArrays(multiLeagues[i], nextGen[i], ACTUALLEAGUES, ACTUALTEAMS);
		}

		//cout << endl << "AFTER TRADE" << endl;
		//for (int i = 0; i < ACTUALLEAGUES; i++)  //PUSHBACK LEAGUES
		//{
		//	findDifferenceSHOW(nextGen[i], ACTUALTEAMS);
		//}

		numloops++;

		//SORT ARRAY
		for (int i = 0; i < ACTUALLEAGUES; i++)
			maxDifference[i] = findDifferenceNOSHOW(multiLeagues[i], ACTUALTEAMS);

		//SORTS LEAGUES IN SOLUTION BY WAR
		Team temp2[NUMTEAMS];
		for (int i = 0; i < ACTUALLEAGUES; i++)
		{
			for (int j = i + 1; j < ACTUALLEAGUES; j++)
			{
				if (maxDifference[i] > maxDifference[j])
				{
					swapArrays(temp2, multiLeagues[i], ACTUALTEAMS);
					swapArrays(multiLeagues[i], multiLeagues[j], ACTUALTEAMS);
					swapArrays(multiLeagues[j], temp2, ACTUALTEAMS);
					swap(maxDifference[i], maxDifference[j]);
				}

				for (int i = 0; i < ACTUALLEAGUES; i++)
				{
					findDifferenceNOSHOW(multiLeagues[i], ACTUALTEAMS);
				}
			}
		}


		//Print every nth generation
		if (gencount == numGenDisplay)
		{
			cout << endl << "GENERATION  " << numloops << "! (top " << numTopDogs << " leagues)" << endl;
			for (int i = 0; i < ACTUALLEAGUES; i++)      //showing top 3 from each generation
			{
				findDifferenceSHOW(multiLeagues[i], ACTUALTEAMS);
			}
			gencount = 1;
		}
		else
		{
			for (int i = 0; i < ACTUALLEAGUES; i++)      //showing top 3 from each generation
			{
				findDifferenceNOSHOW(multiLeagues[i], ACTUALLEAGUES);
			}
			gencount++;
		}
		
	}
}

//functions
double findDifferenceSHOW(Team t[], int num)
{
	double greatest = t[0].getTeamWAR();
	double least = t[0].getTeamWAR();
	double temp, difference;

	for (int i = 0; i < num; i++)
	{
		temp = t[i].getTeamWAR();
		if (temp > greatest)
			greatest = temp;
		if (temp < least)
			least = temp;
	}
	difference = (greatest - least);

	//cout << "Greatest:  " << greatest << endl;
	//cout << "Least:  " << least << endl;
	cout << "Difference of League:  " << difference << endl;

	return difference;
}
double findDifferenceNOSHOW(Team t[], int numTeams)
{
	double greatest = t[0].getTeamWAR();	//variable to keep track of largest team WAR
	double least = t[0].getTeamWAR();		//variable to keep track of smallest team WAR
	double temp, difference;				//variables to hold difference and a temporary value
	for (int i = 0; i < numTeams; i++)		//loop to check each team in a league
	{
		temp = t[i].getTeamWAR();			//set temp variable to current team WAR value
		if (temp > greatest)				//if temp value > greatest value, 
			greatest = temp;						//set greatest to temp
		if (temp < least)					//if temp value < least value,
			least = temp;							//set least to temp
	}
	difference = (greatest - least);		//difference = greatest team WAR - least team WAR
	return difference;						//return the difference for the league
}
void makeTeamsArray(string t[])
{
	//t[NUMTEAMS];
	ifstream inFile;
	inFile.open("teams.txt");  //open file for reading
	int i = 0;
	{
		for (string line; getline(inFile, line); )
		{
			t[i] = line;
			i++;
		}
	}
	inFile.close();  //close file
}
void makePlayerArray(Player p[])
{
	ifstream inFile;
	inFile.open("baseball.txt");  //open file for reading
	int i = 0;
	{
		for (string line; getline(inFile, line); )
		{
			p[i].getPlayer(line);
			i++;
		}
	}
	inFile.close();  //close file
}
void draftTeam(string tName, Player team[], double & teamWAR, Player p[], int teamSize)
{
	random_device rd; // obtain a random number from hardware
	mt19937 gen(rd()); // seed the generator
	uniform_int_distribution<> distr(0, 559); // define the range	}

	int playerCount = 0;
	int pCount = 0;
	int cCount = 0;
	int infCount = 0;
	int ofCount = 0;

	teamWAR = 0.0;

	//cout << "team name: " << tName << endl;
	while (playerCount < teamSize)
	{
		int random = distr(gen);
		if (p[random].isHeDrafted() == false)
		{
			if (p[random].getPosition() == "P")
			{
				if (pCount < 3)
				{
					p[random].draftPlayer();
					team[playerCount] = p[random];
					playerCount++;
					pCount++;
				}
			}
			else if (p[random].getPosition() == "C")
			{
				if (cCount < 2)
				{
					p[random].draftPlayer();
					team[playerCount] = p[random];
					playerCount++;
					cCount++;
				}
			}
			else if (p[random].getPosition() == "INF")
			{
				if (infCount < 6)
				{
					p[random].draftPlayer();
					team[playerCount] = p[random];
					playerCount++;
					infCount++;
				}
			}
			else if (p[random].getPosition() == "OF")
			{
				if (ofCount < 6)
				{
					p[random].draftPlayer();
					team[playerCount] = p[random];
					playerCount++;
					ofCount++;
				}
			}
		}
	}

	//sort here
	Player temp;
	for (int i = 0; i < TEAM_SIZE; i++)
	{
		for (int j = i + 1; j < TEAM_SIZE; j++)
		{
			if (team[i].getEnumPos() > team[j].getEnumPos())
			{
				temp = team[i];
				team[i] = team[j];
				team[j] = temp;
			}
		}
	}


	for (int i = 0; i < teamSize; i++)
	{
		teamWAR += team[i].getWAR();
	}
	//cout << "Total Team WAR:   " << teamWAR << endl;
	//cout << "**************************" << endl;

	return;
}
void createLeague(int numt, string teams[], Player p[], Team league[])
{
	for (int k = 0; k < numt; k++)//place into fcn for solutions, actual teams
	{
		double teamScore;
		Player aTeam[TEAM_SIZE];
		draftTeam(teams[k], aTeam, teamScore, p, TEAM_SIZE);
		league[k].InitTheTeam(teams[k], aTeam, teamScore);
	}

	league->releaseAll(p);
	return;
}
int setupNumTeams()
{
	int numt = 0;
	while (true)
	{
		cout << "Enter desired number of teams in each league (do not go over 15 for now):   ";
		cin >> numt;
		cout << endl;
		if (numt > 15 || numt <= 0)
			cout << "Invalid number of teams... try again" << endl;
		else
			break;
	}

	return numt;
}
int setupNumLeagues()
{
	int numl = 0;
	while (true)
	{
		cout << "Enter number of leagues per Generation:   ";
		cin >> numl;
		cout << endl;
		if (numl > 20 || numl <= 0)
			cout << "Invalid number of leagues... try again" << endl;
		else
			break;
	}

	return numl;
}
void swapArrays(Team arr1[], Team arr2[], int size) {
	Team temp[NUMTEAMS];
	for (int i = 0; i < size; i++) {
		temp[i] = arr1[i];
		arr1[i] = arr2[i];
		arr2[i] = temp[i];
	}

	return;
}
void tradePlayers(Team league[], int numteams, int numleagues, int rnum)
{
	HANDLE hConsole = GetStdHandle(STD_OUTPUT_HANDLE);

	int randteam1, randteam2, randplayer1, randplayer2;
	Player p1, p2;
	while (true)
	{
		randteam1 = rand() % numteams + 0;
		randteam2 = rand() % numteams + 0;
		if (randteam1 != randteam2)
			break;
	}

	for (int k = 0; k < 5; k++)   //swap players k dif times
	{
		//cout << "trade" << k << endl;
		while (true)
		{
			randplayer1 = rand() % TEAM_SIZE + 0;
			randplayer2 = rand() % TEAM_SIZE + 0;
			if (randplayer1 != randplayer2 && randplayer1 < randplayer2)
				break;
		}

		//cout << "BEFORE TRADE:" << endl;
		//cout << endl << "League " << rnum << " Team " << randteam1 << endl;
		//cout << "Random player range:  " << randplayer1 << " - " << randplayer2 << endl;
		//for (int k = 0; k < TEAM_SIZE; k++)
		//{
		//	if (k >= randplayer1 && k <= randplayer2)
		//	{
		//		SetConsoleTextAttribute(hConsole, FOREGROUND_GREEN | FOREGROUND_INTENSITY);   //set color of traded players to green
		//		league[randteam1].getPlayer(k).displayPlayer();
		//	}
		//	else
		//	{
		//		SetConsoleTextAttribute(hConsole, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);   //reset color
		//		league[randteam1].getPlayer(k).displayPlayer();
		//	}
		//}
		//SetConsoleTextAttribute(hConsole, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);   //reset color
		//
		//cout << endl << "League " << rnum << " Team " << randteam2 << endl;
		//for (int k = 0; k < TEAM_SIZE; k++)
		//{
		//	if (k >= randplayer1 && k <= randplayer2)
		//	{
		//		SetConsoleTextAttribute(hConsole, FOREGROUND_GREEN | FOREGROUND_INTENSITY);   //set color of traded players to green
		//		league[randteam2].getPlayer(k).displayPlayer();
		//	}
		//	else
		//	{
		//		SetConsoleTextAttribute(hConsole, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);   //reset color
		//		league[randteam2].getPlayer(k).displayPlayer();
		//	}
		//}
		//SetConsoleTextAttribute(hConsole, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);   //reset color

		//cout << "*********************************************************" << endl;
		//cout << randteam1 << "," << randteam2 << endl;
		//cout << randplayer1 << "," << randplayer2 << endl;
		//cout << "*********************************************************" << endl;


		for (int i = randplayer1; i <= randplayer2; i++)
		{
			p1 = league[randteam1].getPlayer(i);     //player from team 1 at index
			p2 = league[randteam2].getPlayer(i);     //player from team 2 at index
			league[randteam1].setPlayer(i, p2);      //swap
			league[randteam2].setPlayer(i, p1);      //swap
		}

		//cout << "AFTER TRADE:" << endl;
		//cout << endl << "League " << rnum << " Team " << randteam1 << endl;
		//cout << "Random player range:  " << randplayer1 << " - " << randplayer2 << endl;
		//for (int k = 0; k < TEAM_SIZE; k++)
		//{
		//	if (k >= randplayer1 && k <= randplayer2)
		//	{
		//		SetConsoleTextAttribute(hConsole, FOREGROUND_GREEN | FOREGROUND_INTENSITY);   //set color of traded players to green
		//		league[randteam1].getPlayer(k).displayPlayer();
		//	}
		//	else
		//	{
		//		SetConsoleTextAttribute(hConsole, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);   //reset color
		//		league[randteam1].getPlayer(k).displayPlayer();
		//	}
		//}
		//SetConsoleTextAttribute(hConsole, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);   //reset color
		//
		//cout << endl << "League " << rnum << " Team " << randteam2 << endl;
		//for (int k = 0; k < TEAM_SIZE; k++)
		//{
		//	if (k >= randplayer1 && k <= randplayer2)
		//	{
		//		SetConsoleTextAttribute(hConsole, FOREGROUND_GREEN | FOREGROUND_INTENSITY);   //set color of traded players to green
		//		league[randteam2].getPlayer(k).displayPlayer();
		//	}
		//	else
		//	{
		//		SetConsoleTextAttribute(hConsole, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);   //reset color
		//		league[randteam2].getPlayer(k).displayPlayer();
		//	}
		//}
		//SetConsoleTextAttribute(hConsole, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);   //reset color

	}
	return;
}
void copyArrays(Team orig[], Team newarr[], int numleag, int numt)
{
	//cout << "arr1 BEFORE" << endl;
	//for (int i = 0; i < TEAM_SIZE; i++)
	//{
	//	orig->getPlayer(i).displayPlayer();
	//}
	//cout << endl;

	//cout << "arr2 BEFORE" << endl;
	//for (int i = 0; i < TEAM_SIZE; i++)
	//{
	//	newarr->getPlayer(i).displayPlayer();
	//}
	//cout << endl;

	Team temp[NUMTEAMS];
	for (int i = 0; i < numt; i++)
	{
		temp[i] = newarr[i];
		orig[i] = temp[i];
	}

	//cout << "arr1 AFTER" << endl;
	//for (int i = 0; i < TEAM_SIZE; i++)
	//{
	//	orig->getPlayer(i).displayPlayer();
	//}
	//cout << endl;

	//cout << "arr2 AFTER" << endl;
	//for (int i = 0; i < TEAM_SIZE; i++)
	//{
	//	newarr->getPlayer(i).displayPlayer();
	//}
	//cout << endl;

	return;
}
void playerMutation(Team league[], int numteams, int numleagues, int rnum)
{
	Player temp;
	double pWAR;
	int randteam = rand() % numteams + 0;
	int randplayer = rand() % TEAM_SIZE + 0;

	//double war = -1.2 + static_cast<double>(rand()) / (RAND_MAX / (11.4 - (-1.2)));
	double adjustment = -3 + static_cast<double>(rand()) / (RAND_MAX / (3 - (-3)));

	//cout << "RandomLeague:" << rnum << " RandomTeam:" << randteam << " RandomPlayer:" << randplayer << endl;
	//league[randteam].getPlayer(randplayer).displayPlayer();
	//cout << "WAR BEFORE mutation: " << league[randteam].getPlayer(randplayer).getWAR() << endl;

	temp = league[randteam].getPlayer(randplayer);
	pWAR = temp.getWAR();
	pWAR = pWAR + adjustment;
	double newWar = round(pWAR * 10) / 10.0;
	temp.changeWAR(newWar);
	league[randteam].setPlayer(randplayer, temp);

	//cout << "WAR AFTER mutation: " << league[randteam].getPlayer(randplayer).getWAR();

	return;
}




/*for (int i = 0; i < ACTUALLEAGUES; i++)
{
	for (int j = 0; j < ACTUALTEAMS; j++)
	{
		for (int k = 0; k < TEAM_SIZE; k++)
		{
			cout << "League " << i << " Team " << j << " Player " << k << endl;
			multiLeagues[i][j].getPlayer(k).displayPlayer();
		}
	}
}*/
